models/Objetos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "objetos".
 *
 * @property int $cod_items
 * @property string|null $nombre
 * @property string|null $descripcion
 * @property int|null $precio
 *
 * @property Compran[] $comprans
 */
class Objetos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'objetos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nombre', 'descripcion', 'precio'], 'required'],
            [['descripcion'], 'string'],
            [['precio'], 'integer'],
            [['nombre'], 'string', 'max' => 20],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'cod_items' => 'Cod Items',
            'nombre' => 'Nombre',
            'descripcion' => 'Descripcion',
            'precio' => 'Precio',
        ];
    }

    /**
     * Gets query for [[Comprans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getComprans()
    {
        return $this->hasMany(Compran::class, ['cod_items' => 'cod_items']);
    }
    
    
    
    public function beforeSave($insert)
    {
        if ($insert) {
            $this->cod_items = $this->generateUniqueCodItems();
        }
        return parent::beforeSave($insert);
    }

    private function generateUniqueCodItems()
    {
        do {
            $randomNumber = rand(1000, 9999); // Genera un número aleatorio de 4 dígitos
        } while (self::find()->where(['cod_items' => $randomNumber])->exists());

        return $randomNumber;
    }
}

controllers/ObjetosController.php
<?php

namespace app\controllers;

use app\models\objetos;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\Monedero;
use app\models\ObjetosComprados;


/**
 * ObjetosController implements the CRUD actions for objetos model.
 */
class ObjetosController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all objetos models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $monedero = $this->findMonedero(1);
        $objetos = Objetos::find()->all();
        $objetosComprados = ObjetosComprados::find()->all();
        $dataProvider = new ActiveDataProvider([
            'query' => objetos::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'cod_items' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'objetos' => $objetos,
            'dataProvider' => $dataProvider,
            'monedero' => $monedero,
            'objetosComprados' => $objetosComprados,

            
        ]);
    }

    /**
     * Displays a single objetos model.
     * @param int $cod_items Cod Items
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($cod_items)
    {
        return $this->render('view', [
            'model' => $this->findModel($cod_items),
        ]);
    }

    /**
     * Creates a new objetos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new objetos();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['index', 'cod_items' => $model->cod_items]);
            }
        } else {
            $model->loadDefaultValues();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing objetos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $cod_items Cod Items
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($cod_items)
    {
        $model = $this->findModel($cod_items);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'cod_items' => $model->cod_items]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing objetos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $cod_items Cod Items
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($cod_items)
    {
        $this->findModel($cod_items)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the objetos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $cod_items Cod Items
     * @return objetos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     
     * 
     * 
     * 
     * 
     * 
     * 
    protected function findModel($cod_items)
    {
        if (($model = objetos::findOne(['cod_items' => $cod_items])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    */
    
    
    

    protected function findModel($cod_items)
    {
        if (($model = Objetos::findOne($cod_items)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('El objeto solicitado no existe.');
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function actionComprar()
    {
        //Obtiene el cod_item 
        $cod_items = \Yii::$app->request->post('cod_items');
        //Inicializa la transaccion de la base de datos
        $transaction = \Yii::$app->db->beginTransaction();
        try {
            //procesa la compra y obtiene el objetos
            $objeto = $this->procesarCompra($cod_items);
            //confirma transaccion
            $transaction->commit();
            //transmite el success
            \Yii::$app->session->setFlash('success', 'Compra realizada con éxito.');

            //agrega el objeto comprado a la sesión
            $objetosComprados = \Yii::$app->session->get('objetosComprados', []);
            $objetosComprados[] = $objeto;
            \Yii::$app->session->set('objetosComprados', $objetosComprados);

            
        //maneja el error y revierte la transaccion
        } catch (\Exception $e) {
            $transaction->rollBack();
            \Yii::$app->session->setFlash('error', 'Ha ocurrido un error al realizar la compra.');
        }
        
        return $this->redirect(['index']);
    }


    private function procesarCompra($cod_items)
    {
        //busca el modelo del objeto
        $objeto = $this->findModel($cod_items);
        $monedero = $this->findMonedero(1); // Asumiendo que el cod_mon del monedero es 1

        //verifica si hay dinero suficiente en el monedero
        if (!$monedero || $monedero->cantidad < $objeto->precio) {
            throw new \Exception('Fondos insuficientes.');
        }
        
        //descuenta el precio del objeto al monedero
        $monedero->cantidad -= $objeto->precio;
        
        //guarda la nueva cantidad de dinero
        if (!$monedero->save()) {
            throw new \Exception('Error al guardar el monedero.');
        }

        //crea un registro de objetos comprados
        $objetoComprado = new ObjetosComprados();
        $objetoComprado->cod_items = $cod_items;
        //establece el objeto como disponible
        $objetoComprado->disponible = 1; 
        //guarda el objeto comprado
        if (!$objetoComprado->save()) {
            throw new \Exception('Error al guardar en objetos_comprados.');
        }
    }

    //busca el monedero
    private function findMonedero($cod_mon)
    {
        if (($monedero = Monedero::findOne($cod_mon)) !== null) {
            return $monedero;
        }
        throw new NotFoundHttpException('El monedero no existe.');
    }

    
    






    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

}

views/objetos/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\objetos $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="objetos-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'cod_items')->textInput() ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'descripcion')->textarea(['rows' => 6]) ?>

    <?= $form->field($model, 'precio')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/objetos/create.php
<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Objetos */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="objetos-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'descripcion')->textarea(['rows' => 6]) ?>

    <?= $form->field($model, 'tipo')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'precio')->textInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/objetos/index.php
<?php

use app\models\objetos;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider 

$this->title = 'Objetos';
$this->params['breadcrumbs'][] = $this->title;
*/
?>
<div class="objetos-index">

    <h1><?= Html::encode($this->title) ?></h1>

    
    <div class="container mt-5">
        <div class="bi-exp">
            <img src="<?= Yii::getAlias('@web') ?>/img/tienda.jpg" alt="Imagen" width="60px"  class="bi-fondo">
            <h2 class="titulo-bi">Tienda</h2>
        </div>
    </div>

    <style>
        .bi-exp {
            position: relative;
            border: 3px solid #AAD399;
            padding: 20px;
            color: #AAD399;
            box-shadow: 0 0 20px rgba(0, 255, 204, 0.5);
            text-shadow: 0 0 5px #AAD399;
            margin-bottom: 50px;
        }
        .bi-fondo {
            position: absolute;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            object-fit: cover;
            z-index: -1;
        }
        .titulo-bi {
            color: #F5DF61;
            text-shadow: 0 0 10px #F5DF61;
            position: relative;
            z-index: 1;
            
        
        }
    </style>
    <p>
        <?= Html::a('Crear Objetos', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    
    
    <style>
        .btn.btn-success {
        /* tamaño del botón */
            padding: 10px 20px; 
            font-size: 1em; 
            border: none;
            border-radius: 20px;
            background-color: #AAD399;
            color: black; 
            display: inline-block;
            cursor: pointer;
            box-shadow: 0 4px #759e64; 
            transition-duration: 0.4s;
        }

        .btn.btn-success:hover {
            background-color: #F5DF61;
            box-shadow: 0 4px #c9b649;
        }

        .btn.btn-success:active {
            background-color: #3e8e41; 
            box-shadow: 0 2px #666; 
            transform: translateY(2px); 
        }
    </style>

    
 <!--Contenedor de las monedas-->
<div class="monedero-info" style="color: #aad399; border: #aad399; top: 200px; right: 10px; background-color: transparent; padding: 10px; border-radius: 5px; ">
    
    <br>
    <!--Funcion encode para mostrar la cantidad de monedas-->
    <strong>Cantidad:</strong> <?= Html::encode($monedero->cantidad) ?> monedas
</div>  
    
    
    
    
    
    
    
    
    

<div class="objetos-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <div class="row">
        <!--BUCLE MOSTRAR OBJETOS CREADOS-->
        <?php foreach ($objetos as $objeto): ?> 
            <div class="col-sm-4">
                <div class="card">
                    <div class="card-body">
                        <!--Nombre del objeto + otros datos-->
                        <h5 class="card-title"><?= Html::encode($objeto->nombre) ?></h5>
                        <p class="card-text"><?= Html::encode($objeto->descripcion) ?></p>
                        <p class="card-text">Precio: <?= Html::encode($objeto->precio) ?> monedas</p>
                        
                        <!--Formulario para comrar objetos-->
                        <?= Html::beginForm(['objetos/comprar'], 'post') ?>
                            <!--Campo oculto de la clave-->
                            <?= Html::hiddenInput('cod_items', $objeto->cod_items) ?>
                            <?= Html::submitButton('Comprar', ['class' => 'btn btn-primary']) ?>
                        <?= Html::endForm() ?>
                    </div>
                </div>
            </div>
        <?php endforeach; ?>
    </div>
</div>
    
  <!--BUCLE MOSTRAR OBJETOS COMPRADOS-->
  <div class="objetos-comprados">
    <h2>Objetos Comprados</h2>
    <ul>
        <?php foreach ($objetosComprados as $comprado): ?>
            <li><?= Html::encode($comprado->objeto->nombre) ?></li>
        <?php endforeach; ?>
    </ul>
</div>

    
    
<!--MAQUETACION DE CARDS-->
<style>
    
    .grid-view th {
        background-color: transparent; 
        color: #DA107B; 
        border-bottom: 2px solid #aad399; 
        border-right: 2px solid #aad399; 
        border-left: 2px solid #aad399;
        border-top: 2px solid #aad399;
        color: #aad399; 
        border: 2px solid #aad399; 
        box-shadow: 0 0 5px #aad399; 
        padding: 10px 20px; 
        font-size: 16px; 
        font-weight: bold; 
        border-radius: 15px; 
        box-shadow: 0 0 10px rgba(0, 255, 0, 0.5);
        
    }

    .grid-view td {
        background-color: transparent;
        color: #aad399; 
        border-bottom: 2px solid #aad399; 
        border-right: 2px solid #aad399; 
        border-left: 2px solid #aad399;
        border-top: 2px solid #aad399;
        color: #aad399; 
        border: 1px solid #aad399; 
        box-shadow: 0 0 5px #aad399; 
        padding: 10px 20px; 
        font-size: 16px; 
        font-weight: bold;
        border-radius: 15px; 
        box-shadow: 0 0 10px rgba(0, 255, 0, 0.5); 
        
    }
    
    
    .barra-vida-container {
        width: 100%;
        background-color: #e0e0e0;
        border-radius: 4px;
        margin: 10px 0;
    }

    .barra-vida {
        height: 20px;
        background-color: #76ff03;
        border-radius: 4px;
        text-align: center;
        line-height: 20px;
        color: black;
    }

    

</style>





</div>

views/objetos/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\objetos $model */

$this->title = 'Update Objetos: ' . $model->cod_items;
$this->params['breadcrumbs'][] = ['label' => 'Objetos', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->cod_items, 'url' => ['view', 'cod_items' => $model->cod_items]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="objetos-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/objetos/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\objetos $model */

$this->title = $model->cod_items;
$this->params['breadcrumbs'][] = ['label' => 'Objetos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="objetos-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'cod_items' => $model->cod_items], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'cod_items' => $model->cod_items], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'cod_items',
            'nombre',
            'descripcion:ntext',
            'precio',
        ],
    ]) ?>

</div>